import tecplot as tp
tp.session.connect()

ds = tp.active_frame().dataset
iso_zones = ds.zones("Iso*")

times = []
maxx = []
speed = []
# Assuming that the zones are given in time order
for z in iso_zones:
    maxx.append(z.values("X").max())
    times.append(z.solution_time)
    if len(maxx) == 1:
        speed.append(0)
    else:
        dx = (maxx[-1] - maxx[-2])
        dt = (times[-1] - times[-2])
        speed.append(dx/dt)
        
# Save the results to a Tecplot data file. We do this by creating a
# new dataset in Tecplot 360 with the results and saving to a file.
new_frame = tp.active_page().add_frame()
ds = new_frame.create_dataset("Flame Speed", var_names=["Solution Time", "Flame Speed"])
zone = ds.add_ordered_zone("Flame Speed", shape=len(times))
zone.values("Solution Time")[:] = times
zone.values("Flame Speed")[:] = speed
tp.data.save_tecplot_ascii("flame_speed.dat", frame=new_frame)
# Weve saved the data to disk and no longer need the frame around
tp.active_page().delete_frame(new_frame)

